package repository

import (
	"fmt"
	"time"

	"be.ems/src/framework/database/db"
	"be.ems/src/framework/logger"
	"be.ems/src/modules/system/model"
)

// NewSysLoginSource 实例化数据层
var NewSysLoginSource = &SysLoginSource{}

// SysLoginSource 认证源数据层处理
type SysLoginSource struct{}

// SelectByPage 分页查询集合
func (r SysLoginSource) SelectByPage(query map[string]string) ([]model.SysLoginSource, int64) {
	tx := db.DB("").Model(&model.SysLoginSource{})
	// 查询条件拼接
	if v, ok := query["name"]; ok && v != "" {
		tx = tx.Where("name like ?", v+"%")
	}
	if v, ok := query["type"]; ok && v != "" {
		tx = tx.Where("type = ?", v)
	}
	if v, ok := query["beginTime"]; ok && v != "" {
		if len(v) == 10 {
			v = fmt.Sprintf("%s000", v)
		}
		tx = tx.Where("create_time >= ?", v)
	}
	if v, ok := query["endTime"]; ok && v != "" {
		if len(v) == 10 {
			v = fmt.Sprintf("%s999", v)
		}
		tx = tx.Where("create_time <= ?", v)
	}

	// 查询结果
	var total int64 = 0
	rows := []model.SysLoginSource{}

	// 查询数量为0直接返回
	if err := tx.Count(&total).Error; err != nil || total <= 0 {
		return rows, total
	}

	// 查询数据分页
	pageNum, pageSize := db.PageNumSize(query["pageNum"], query["pageSize"])
	tx = tx.Limit(pageSize).Offset(pageSize * pageNum)
	err := tx.Find(&rows).Error
	if err != nil {
		return rows, total
	}
	return rows, total
}

// Select 查询集合
func (r SysLoginSource) Select(param model.SysLoginSource) []model.SysLoginSource {
	tx := db.DB("").Model(&model.SysLoginSource{})
	// 查询条件拼接
	if param.UID != "" {
		tx = tx.Where("uid = ?", param.UID)
	}
	if param.Type != "" {
		tx = tx.Where("type = ?", param.Type)
	}
	if param.Name != "" {
		tx = tx.Where("name = ?", param.Name)
	}
	if param.ActiveFlag != "" {
		tx = tx.Where("active_flag = ?", param.ActiveFlag)
	}

	// 查询数据
	rows := []model.SysLoginSource{}
	if err := tx.Find(&rows).Error; err != nil {
		return rows
	}
	return rows
}

// SelectByIds 通过ID查询信息
func (r SysLoginSource) SelectByIds(ids []int64) []model.SysLoginSource {
	rows := []model.SysLoginSource{}
	if len(ids) <= 0 {
		return rows
	}
	tx := db.DB("").Model(&model.SysLoginSource{})
	// 构建查询条件
	tx = tx.Where("id in ?", ids)
	// 查询数据
	if err := tx.Find(&rows).Error; err != nil {
		logger.Errorf("query find err => %v", err.Error())
		return rows
	}
	return rows
}

// Insert 新增信息 返回新增数据ID
func (r SysLoginSource) Insert(param model.SysLoginSource) int64 {
	if param.CreateBy != "" {
		ms := time.Now().UnixMilli()
		param.UpdateBy = param.CreateBy
		param.UpdateTime = ms
		param.CreateTime = ms
	}
	// 执行插入
	if err := db.DB("").Create(&param).Error; err != nil {
		logger.Errorf("insert err => %v", err.Error())
		return 0
	}
	return param.Id
}

// Update 修改信息 返回受影响行数
func (r SysLoginSource) Update(param model.SysLoginSource) int64 {
	if param.Id <= 0 {
		return 0
	}
	if param.UpdateBy != "" {
		param.UpdateTime = time.Now().UnixMilli()
	}
	tx := db.DB("").Model(&model.SysLoginSource{})
	// 构建查询条件
	tx = tx.Where("id = ?", param.Id)
	tx = tx.Omit("id", "create_by", "create_time")
	// 执行更新
	if err := tx.Updates(param).Error; err != nil {
		logger.Errorf("update err => %v", err.Error())
		return 0
	}
	return tx.RowsAffected
}

// DeleteByIds 批量删除信息 返回受影响行数
func (r SysLoginSource) DeleteByIds(ids []int64) int64 {
	if len(ids) <= 0 {
		return 0
	}
	tx := db.DB("").Where("id in ?", ids)
	// 执行删除
	if err := tx.Delete(&model.SysLoginSource{}).Error; err != nil {
		logger.Errorf("delete err => %v", err.Error())
		return 0
	}
	return tx.RowsAffected
}

// DeleteByUserSource 通过用户源删除用户 返回受影响行数
func (r SysLoginSource) DeleteByUserSource(uid string) int64 {
	if uid == "" || uid == "#" {
		return 0
	}
	tx := db.DB("").Where("user_source = ?", uid)
	// 执行删除
	if err := tx.Delete(&model.SysUser{}).Error; err != nil {
		logger.Errorf("delete err => %v", err.Error())
		return 0
	}
	return tx.RowsAffected
}
